#ifndef DUDE_H
#define DUDE_H

#include "behavior.h"

class Dude : public Info
{
private:
    Coord m_pos;
    Map *p_map;
    int m_team;
    bool m_dead;
    bool m_success;
    int m_inventory;
    char m_memory[DUDE_MEMORY_SIZE];
    Com m_comData;
    
public:
    Dude(const Coord &_pos, Map *_map, int &_team);
    char* getMemory();
    int getTeam(){ return m_team; }
    void setSuccess(bool success) { m_success = success; }
    void setInventory(int item) { m_inventory = item; }
    void trespass() { m_dead = true; }
    const Coord& getPos() { return m_pos; }
    void move(Dir d);
    void receiveComData(const Com &comData);
    
    virtual bool getSuccess() const { return m_success; }
    virtual int getInventory() const { return m_inventory; }
    virtual const Com& getCom() const { return m_comData; }
    virtual PixelType getNear(Dir d) const;
    virtual int getInfo(Dir d) const;
};

#endif // DUDE_H
