#include "mainwindow.h"
#include "drawwidget.h"
#include "ui_mainwindow.h"
#include "simulationdialog.h"
#include "simulation.h"

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    connect(ui->startButton, SIGNAL(pressed()), this, SLOT(openSimuDialog()));
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::openSimuDialog()
{
    SimulationDialog *dialog = new SimulationDialog(this);
    dialog->setWindowTitle("Starting a new Simulation");
    connect(dialog, SIGNAL(sendError(QString, int)), ui->statusBar, SLOT(showMessage(QString, int)));
    int ret = dialog->exec();
    if(ret == QDialog::Accepted)
    {
        Simulation *simu = dialog->getSimulation();
        ui->drawWidget->startSimulation(simu->getMap());
        // TODO set a timer to update the simulation
    }
}
